include_file("resource://com.presonus.musicdevices/sdk/midiprotocol.js");include_file("resource://com.presonus.musicdevices/sdk/controlsurfacedevice.js");const Global={version:"1.0",deviceSyncID:"iCONController",channelCount:8,macroCount:8,scenes:{track:{id:"track",text0:null,text1:"*TRACK*",focusText0:"[TRACK]",focusText1:"{trackName}"},pan:{id:"pan",text0:null,text1:"*PAN*",focusText0:"  [PAN]",focusText1:"{trackName}"},send:{id:"send",text0:" *SEND*",text1:"{index}/{count}",focusText0:"[SENDS]",focusText1:"{trackName}"},cue:{id:"cue",text0:"  *CUE*",text1:"{index}/{count}",focusText0:" [CUES]",focusText1:"{trackName}"},plugin:{id:"plugin",text0:" *PLUG*",text1:"{index}/{count}",focusText0:" [PLUG]",focusText1:"{trackName}"},instrument:{id:"instrument",text0:null,text1:"*INST*",focusText0:" [INST]",focusText1:"{trackName}"},macro:{id:"macro",text0:"*MACRO*",text1:"{index}/{count}",focusText0:"[MACRO]",focusText1:"{trackName}"}},sceneLookup:["track","pan","send","cue","plugin","instrument","macro",],params:{name:"label",select:"selected",multiSelect:"multiselect",color:"color",number:"number",volume:"volume",mute:"mute",solo:"solo",pan:"pan",automationMode:"automationMode",insertsBypass:"Inserts/bypassAll",sendsBypass:"Sends/bypassAll",gain:"InputFX/gain",polarityLeft:"InputFX/invertPhaseL",polarityRight:"InputFX/invertPhaseR",output:"outputPort",input:"recordPort",inputPortIn:"portAssignmentIn",inputPortOut:"portAssignmentOut",monitor:"monitor",record:"recordArmed",levelL:"level1",levelR:"level2",reduction:"reduction",vca:"vcaInputPort",panType:"Panner/pannerType",panStereoMode:"Panner/stereoMode",panBalance:"Panner/panX1",panLeft:"Panner/panX1",panRight:"Panner/panX2",panWidth:"Panner/panWidth",pluginName:"@owner/deviceName",pluginEditorOpen:"@owner/edit",pluginBypass:"bypass",instrument:"synthDevice",sendPort:"sendPort",sendLevel:"sendlevel",sendMute:"sendMute",sendPan:"pan",sendPrefader:"prefader",sendLockPan:"lockPan",cueDestination:"destination",cueLevel:"level",cueMute:"mute",cueLockLevel:"lock",cuePan:"Panner/panX1",cueLockPan:"lockPan",value:"value",title:"title",macroTitle:"title",macroValue:"pilot",pageNumber:"pageNumber",pageCount:"pageCount",pagingStatus:"pagingStatus",pagingStatusFormat:"pagingStatusFormat",pagingMode:"pagingMode",nextPage:"nextPage",prevPage:"prevPage"},folders:{sends:"Sends",cues:"CueMix",plugins:"Inserts"},channelTypes:{audio:"Audio",input:"AudioInput",output:"AudioOutput",audioTrack:"AudioTrack",instrument:"AudioSynth",bus:"AudioGroup",fxBus:"AudioEffect",synthBus:"AudioSynthBus",listenBus:"AudioListenBus",aux:"AudioAux",vca:"AudioVCA",music:"Music",musicTrack:"MusicTrack"},timerTicksPerSecond:2,tapTimeout:250,paramDisplayTimeout:2.5,trackFilters:["RemoteAllBank","Type:AudioTrack","Type:AudioSynth","Type:AudioGroup","Type:AudioVCA","Type:AudioInput","unused","Type:AudioOutput","Type:AudioEffect","RemoteBank","Custom:Spill",],spillBank:"Custom:Spill",allBank:"RemoteAllBank",textRows:{primaryMain:0,primarySub:1,secondaryMain:2,secondarySub:3}};include_file("userSettings.js");class IconDisplay{constructor(n){this.COLS_PER_ROW=56;this.COLS_PER_TRACK=7;this.ROW_COUNT=4;this.device=n;this.rowBuffers=[];for(let n=0;n<this.ROW_COUNT;n++)this.rowBuffers.push(new Array(this.COLS_PER_ROW).fill(32));this.colors=new Array(24).fill(0)}sendText(n,t,i){let u=this.COLS_PER_TRACK*t,r=this.COLS_PER_TRACK;i.length>r&&(i=i.substr(0,r));i=i.padEnd(r);let f=this.rowBuffers[n];for(let n=0;n<i.length;n++)f[u+n]=i.charCodeAt(n);this.sendRowToDevice(n)}sendRowToDevice(n){let i=[],r=0;n<=1?(i=[0,0,102,20,18],n==0&&(r=this.COLS_PER_ROW)):(i=[0,2,78,21,19],n==3&&(r=this.COLS_PER_ROW));let t=new PreSonus.SysexBuffer;t.begin(i);t.push(r);let u=this.rowBuffers[n];for(let n=0;n<u.length;n++)t.push(u[n]);t.end();this.device.sendSysex(t)}setColor(n,t,i,r){let u=3*n;this.colors[u]=t;this.colors[u+1]=i;this.colors[u+2]=r;this.sendColorsToDevice()}sendColorsToDevice(){let n=new PreSonus.SysexBuffer;n.begin([0,2,78,22,20]);for(let t=0;t<this.colors.length;t++)n.push(this.colors[t]);n.end();this.device.sendSysex(n)}}class RGBColorHandler extends PreSonus.ControlHandler{constructor(n,t){super();this.name=n;this.channel=t}sendValue(n){let e=n>>24&255;e==0&&(n=2130706432);let r=n>>1&127,t=n>>9&127,i=n>>17&127,o=.7+.3*(t/128);i*=o;let u=110,f=Math.max(r,t,i);if(f>u){let n=u/f;r=r*n;t=t*n;i=i*n}this.device.display.setColor(this.channel,r,t,i)}}class MasterClipHandler extends PreSonus.ControlHandler{constructor(n){super();this.name=n}sendValue(n){n?this.sendMidi(144,101,127):this.sendMidi(144,101,0)}}class VPotMeterHandler extends PreSonus.ControlHandler{constructor(n,t,i){super();this.name=n;this.channel=t;this.displayMode=i}sendValue(n){let t=this.displayMode<<4,i=Math.round(n*10)+1;t|=i;let r=48+this.channel;this.sendMidi(176,r,t)}}class TextDisplayHandler extends PreSonus.ControlHandler{constructor(n,t,i){super();this.name=n;this.channel=i;this.row=t}sendValue(n){let t=n.toString();if(t.length>7)if(/^(\d|[+-])/.test(t))t=t.replace(/\s+/g,""),t=t.substr(0,7);else switch(Settings.labelTruncation){case"includeEnd":t=t.replace(/\s+/g,"");t=t.substr(0,4)+t.substr(t.length-3,3);break;case"allWords":t=this.truncateTextAllWords(t);break;default:t=t.replace(/\s+/g,"");t=t.substr(0,7)}this.device.display.sendText(this.row,this.channel,t)}truncateTextAllWords(n){let u=n.match(/[A-Z]+(?![a-z])|[A-Z]?[a-z]+|\d+/g),t=u.length;t>7&&(t=7);let e=Math.floor(7/t),r=[],i=[],f=0;for(let n=0;n<t;n++)r.push(u[n].length),i.push(e<r[n]?e:r[n]),f+=i[n];let o=!1;while(!o){let n=7-f,u=n;for(let u=0;u<t;u++)n>0&&i[u]+1<=r[u]&&(i[u]++,f++,n--);o=n==0||n==u}let s="";for(let n=0;n<t;n++)s+=u[n].substr(0,i[n]);return s}}class VUMeterHandler extends PreSonus.ControlHandler{constructor(n,t,i,r,u){super();this.name=n;this.channel=i;this.midiChannel=t;this.leftValue=0;this.isMono=r;this.isStereo=!r;this.monoLeftHandler=u;this.isLeftChannel=u==null;this.isRightChannel=u!=null;this.rightChannelPresent=!1}sendValue(n){if(n==null&&(n=0),n==0&&this.isMono&&this.isRightChannel&&(this.monoLeftHandler.rightChannelPresent=!1),this.isStereo||this.isRightChannel||this.isMono&&this.isLeftChannel&&!this.rightChannelPresent){this.isMono&&this.isRightChannel&&this.monoLeftHandler.leftValue>n&&(n=this.monoLeftHandler.leftValue);this.isRightChannel&&n>0&&(this.monoLeftHandler.rightChannelPresent=!0);let t=.76,i=.496,r=.02;if(this.midiChannel>0){let r=.9091,t=.7273,i=.1;if(n<i)n=0;else if(n<=t){let r=t-i;n=(n-i)/r;n=Math.ceil(n*7)}else if(n<=r){let i=r-t;n=(n-t)/i;n=Math.ceil(n*4)+7}else n=12}else if(Settings.changeMeter0dBPosition.charAt(0)=="g")if(n<=t){let i=t-r;n=(n-r)/i;n=Math.ceil(n*7)}else{let i=1-t;n=(n-t)/i;n=Math.ceil(n*5)+7}else if(Settings.changeMeter0dBPosition.charAt(0)=="f")if(n<=i){let t=i-r;n=(n-r)/t;n=Math.ceil(n*7)}else if(n<=t){let r=t-i;n=(n-i)/r;n=Math.ceil(n*4)+7}else n=12;else n=Math.ceil(n*12);let u=this.channel<<4|n;this.sendMidi(208+this.midiChannel,u)}else this.leftValue=n}}class GRMeterHandler extends PreSonus.ControlHandler{constructor(n,t){super();this.name=n;this.channel=t}sendValue(n){if(n){n=1-n;let i=[0,1,2,3,4,5,6,9,12,18,24,36,48],r=Math.floor(n/.00694),t=12;while(t>=0){if(r>=i[t])break;t--}let u=this.channel<<4|t;this.sendMidi(208,u)}}}class TimeCodeHandler extends PreSonus.ControlHandler{constructor(n){super();this.name=n}sendValue(n){if(n=n.replace(/:/g,"."),!Settings.timeCodeLeadingZeros){let t="",i=!0;for(let r=0;r<n.length-1;r++){let u=n.charAt(r),f=n.charAt(r+1);f=="."&&(i=!1);u=="0"&&i?t+=" ":u=="."?(i=!0,t+="."):(t+=u,i=!1)}n=t+n.charAt(n.length-1)}let t=n.length-1,i=!1,r=64;while(r<=73){let u="";if(t>=0&&(u=n.charAt(t)),u==".")i=!0;else{let n=this.convertToByte(u,i);i=!1;this.sendMidi(PreSonus.Midi.kController,r,n);r++}t--}}convertToByte(n,t){let i=32;return n.length>0&&n!=" "&&(i|=16,t&&(i|=64),i|=parseInt(n)),i}}class IconFaderBankDevice extends PreSonus.ControlSurfaceDevice{constructor(){super();this.isExtender=!0;this.display=new IconDisplay(this);this.pollCount=0}onInit(n){super.onInit(n);this.debugLog=!0;this.deviceType=this.isExtender?"Extender":"Main Unit";for(let n=0;n<8;n++){this.addHandler(new RGBColorHandler("channelColor["+n+"]",n));this.addHandler(new VPotMeterHandler("vpotMeter["+n+"]",n,1));let t=new VUMeterHandler("monoMeter["+n+"][LInput]",0,n,!0,null);this.addHandler(t);this.addHandler(new VUMeterHandler("monoMeter["+n+"][RInput]",0,n,!0,t));this.addHandler(new VUMeterHandler("stereoMeter["+n+"][L]",0,n,!1));this.addHandler(new VUMeterHandler("stereoMeter["+n+"][R]",0,n,!1));this.addHandler(new GRMeterHandler("reductionMeter["+n+"]",n));this.addHandler(new TextDisplayHandler("textRowPrimaryMain["+n+"]",Global.textRows.primaryMain,n));this.addHandler(new TextDisplayHandler("textRowPrimarySub["+n+"]",Global.textRows.primarySub,n));this.addHandler(new TextDisplayHandler("textRowSecondaryMain["+n+"]",Global.textRows.secondaryMain,n));this.addHandler(new TextDisplayHandler("textRowSecondarySub["+n+"]",Global.textRows.secondarySub,n))}}onMidiOutConnected(n){super.onMidiOutConnected(n);n&&this.hostDevice.invalidateAll()}sendSysex(n){this.hostDevice.sendSysexEvent(n.data,n.length)}onIdle(){this.pollCount++;this.pollCount>25/Global.timerTicksPerSecond&&(this.pollCount=0,this.sendMessage(Global.deviceSyncID,"poll"))}}class IconMainSharedDevice extends IconFaderBankDevice{constructor(){super();this.isExtender=!1}onInit(n){super.onInit(n);this.addHandler(new TimeCodeHandler("timeCodeSegmentDisplay"));let t=new VUMeterHandler("monoMeter[m][LInput]",1,0,!0,null);this.addHandler(t);this.addHandler(new VUMeterHandler("monoMeter[m][RInput]",1,0,!0,t));this.addHandler(new VUMeterHandler("stereoMeter[m][L]",1,0,!1));this.addHandler(new VUMeterHandler("stereoMeter[m][R]",1,1,!1));this.addHandler(new MasterClipHandler("encoderLED"))}}

class IconDeviceP1M extends IconMainSharedDevice {
constructor() {
super();
// --------------------
// Text Display Rows
// --------------------
// Selects where the different lines of text are placed on the physical display(s).
// Row 0 is the top most row
// Row 3 is the lowest row
// For devices with two screens, rows 0 and 1 are on the top display, 2 and 3 are on the lower display
Global.textRows = {
primaryMain: 1,
primarySub: 0,
secondaryMain: 2,
secondarySub: 3,
}
}
}

class IconDeviceP1Nano extends IconMainSharedDevice {
constructor() {
super();
// --------------------
// Text Display Rows
// --------------------
// Selects where the different lines of text are placed on the physical display(s).
// Row 0 is the top most row
// Row 3 is the lowest row
// For devices with two screens, rows 0 and 1 are on the top display, 2 and 3 are on the lower display
Global.textRows = {
primaryMain: 1,
primarySub: 0,
secondaryMain: 2,
secondarySub: 3,
}
}
}

class IconDeviceV1M extends IconMainSharedDevice {
constructor() {
super();
// --------------------
// Text Display Rows
// --------------------
// Selects where the different lines of text are placed on the physical display(s).
// Row 0 is the top most row
// Row 3 is the lowest row
// For devices with two screens, rows 0 and 1 are on the top display, 2 and 3 are on the lower display
Global.textRows = {
primaryMain: 1,
primarySub: 0,
secondaryMain: 2,
secondarySub: 3,
}
}
}

function createDeviceP1M() {
return new IconDeviceP1M();
}

function createDeviceP1Nano() {
return new IconDeviceP1Nano();
}

function createDeviceV1M() {
return new IconDeviceV1M();
}
